	TITLE ALGB Library Main Module

INCLUDE alromid.h
INCLUDE alextdec.h
INCLUDE keydefs.h

*****************************************************************
* The main module contains the dispatchees of the user words.
* Each routine is named with a NULLNAME compiler directive, and
* has a corresponding entry in the external declarations file.
*****************************************************************
NULLNAME LXAext ( liste -> meta-array )
* Explose un vecteur ou une matrice formelle comme ARRY\->
::
DTYPELIST? NOT?SEMI DUPNULL{}? ?SEMI
DUP CARCOMP
dLISTcase :: LENCOMP UNCOERCE SWAP DUPLENCOMP UNCOERCE
             ROT TWO{}N SWAPINCOMP reversym
             #1+_ONE_DO (DO)
                        INNERCOMP INDEX@ #* #1+ROLL
                        LOOP
             ;
DROP INNERCOMP UNCOERCE
;
*****************************************************************
NULLNAME  AXLext ( array -> liste )
* Transforme un tableau en liste
::
DUPTYPEARRY? NOT?SEMI
xARRY\-> INNER#1=
SWAP COERCESWAP
case {}N
SWAP COERCE NULL{} SWAP
ZERO_DO (DO)
        OVER#2+UNROL {}N DUPLENCOMP
        UNROT >HCOMP
        LOOP
SWAPDROP
;
**************
NULLNAME LXFext ( num, deno -> num/deno )
* transforme une fraction du format numrateur, dnominateur
* polynmes-listes ou entiers au format algbrique
::
CK&DISPATCH1
2LIST :: ( l1, l2 ) ID VX DUPUNROT
         ( l1, x, l2, x ) OVER CARCOMP
         :: ( l1, x, l2, x, 1er element de l2 )
            DTYPELIST?
            NOTcasedrop VALext
            ( l1, x, l2, x, 1er element de l2 )
            SWAP VALext SWAPINCOMP DROPSWAPDROP x^
            ;
         UNROT VALext SWAP x/
         ;
TWENTYONE ( #15 ) :: INCOMPDROP ' U^ ' U/ FIVE SYMBN ;
2REAL NDXFext
;
**************
NULLNAME FXLext ( fraction -> poly2, poly1 ou real2, real1 )
* inverse de LXFext
::
FXNDext
DUP REALcase SIMPext
ID VX DUPUNROT VXXLext UNROT VXXLext SWAP
;
**************
NULLNAME LXXext ( polynme-liste -> polynme algbrique )
* par exemple { 2 1 -1 } -> -1+X+2*X^2
::
DTYPEREAL? ?SEMI ID VX VALext
;
**************
NULLNAME XXLext ( polynme algbrique -> polynme liste )
* inverse de LXXext
::
ID VX VXXLext
;
**************
NULLNAME  CALCext ( algbrique -> fraction algbrique )
* rduit au mme dnominateur des fractions
::
DUPTYPESYMB? NOT?SEMI
RESOROMP FXNDext
' :: DUPTYPESYMB? NOT?SEMI
     INNERCOMP DUPUNROT #1+UNROLL #1-
     pZpargSWAPUn DUP#1=
     ITE_DROP
         :: SYMBN 1GETLAM EVAL ;
     OVER #3+ UNROLL
     DUP#0=csedrp :: SWAP 2GETEVAL
                   { SWAP
                     :: SWAP UNEG SWAP ;
                     :: %2 XSQRext SWAP %2 XSQRext SWAP ;
                     :: USQ SWAP USQ SWAP ;
                     :: ( z z') 2DUP URE SWAP URE x* UNROT
                        (  aa' z z')
                        DUP4UNROLL UIM SWAP UIM x* x+
                        ( z' aa'+bb') SWAPDUP
                        URE DUP x* SWAP UIM DUP x* x+ ;
                     :: ( z z') 2DUP URE SWAP UIM x* UNROT
                        DUP4UNROLL UIM SWAP URE x* x- SWAPDUP
                        URE DUP x* SWAP UIM DUP x* x+ ;
                     :: UCONJ SWAP UCONJ SWAP ;
                     :: UNROT U/ SWAP EVAL %1 ;
                     }
                     { UINV UNEG U\v/ USQ URE UIM UCONJ }
                     5ROLL GETEVext NDXFext
                     ;
     DUP#1=
     ITE_DROP
         :: SYMBN 1GETLAM EVAL ;
     2GETEVAL 4ROLL 2GETEVAL
     { :: 3PICKOVER x* 5UNROLL 4ROLL x*
          UNROT x* x+ SWAP ;
       :: 3PICKOVER x* 5UNROLL 4ROLL x*
          UNROT x* x- SWAP ;
       :: ROT x* UNROT x* SWAP ;
       :: 4ROLL x* UNROT x* ;
       :: U/ DUPUNROT U^ UNROT U^ SWAP ;
       :: 5UNROLL U/ UNROT U/ SWAPROT EVAL %1 ;
       }
     { x+ x- x* U/ U^ }
     7ROLL GETEVext NDXFext
  ;
DUPUNROT { NULLLAM NULLLAM } BIND EVAL ABND
;
**************
NULLNAME ELMGext ( algbrique polynmial -> polynme dvelopp )
* Dveloppe par rapport  toutes les variables rencontres
* Remplace par 0 les rels infrieurs  epsilon
::
ID EPS
' :: CK&DISPATCH1
     real :: DUP %ABS 2GETLAM %< casedrop %0
             ;
     TWO :: C%>% ( re, im ) SWAPDUP ( im, re, re ) %ABS 2GETLAM %<
            ( im , re, re<eps? )
            ITE %0 DUP
            SWAPDROPSWAP
            ( re ou %0, im )
            DUP %ABS 2GETLAM %< caseDROP %>C%
            ;
     list LISTSECOext
     symb :: CSQRext ?SEMI
             TOLISText NOT?SEMI
             SWAP VALext
             ;
     arry :: DUP UABS 2GETLAM %< NOT?SEMI
             %0 UCON
             ;
     ZERO NOP
     ;
{ NULLLAM NULLLAM } BIND
1GETLAM EVAL ABND
;
**************
NULLNAME ELMG3ext ( algbrique, entier -> algbrique )
* Arrondit les scalaires de l'algbrique s'il sont proches
* d'un rationnel de dnominateur l'entier au niveau 1
::
xABS DTYPEREAL? ?SKIP :: DROP %1 ;
ID EPS
' :: CK&DISPATCH1
     real :: 3GETLAM 2DUP %* %0 URND SWAP %/ 2DUP %- %ABS
             2GETLAM %< IT SWAP DROP
             ;
     TWO :: C%>% 1GETLAM EVAL SWAP 1GETLAM EVAL SWAP
            DUP%0= ITE_DROP %>C%
            ;
     symb :: LISTSECOext ELMGext
             ;
     list LISTSECOext
     arry :: xARRY\-> DUPINCOMP #2= IT %*
             COERCEDUP
             ZERO_DO (DO)
                     ( a1,..., an, size, #n )
                     ROT 1GETLAM EVAL OVER#2+UNROL
                     LOOP
             DROP x\->ARRY
             ;
     ZERO NOP
     ;
4NULLLAM{} CDRCOMP BIND
1GETLAM EVAL ABND
;
**************
NULLNAME FACT1ext ( polynme -> poly-liste, {liste des racines} )
* Factorise un polynme, renvoie le coefficient dominant
* et la liste des racines.
::
TWO BINDext
:: CK&DISPATCH1
   list :: DUP EVIDENText
           1GETLAM EVAL
           &COMP
           ;
   idnt :: ID VX EQUALcasedro
           :: { %1 %0 } { %0 } ;
           ONE{}N NULL{}
           ;
   symb :: DUPINCOMP { x* U^ } ROT EQUALPOSCOMP
           DUP#0=case :: SWAP NDROP ID VX VXXLext 2GETEVAL ;
           #1=case :: #1- pZpargSWAPUn DUP#1= ITE_DROP SYMBN
                      OVER#2+UNROL DUP#1= ITE_DROP SYMBN
                      ROTDROP 2GETEVAL ROT 2GETEVAL ROT
                      &COMP UNROT MULText SWAP ;
           #1- pZpargSWAPUn SYMBN
           OVER#2+UNROL DUP#1= ITE_DROP SYMBN
           ROTDROP 2GETEVAL
           ( exposant, poly-liste, racines )
           2DUP 5ROLL CARCOMP COERCE
           ( poly-l, rac , poly-l, rac, exp )
           ONE_DO
                  ( poly-l, rac , Allpoly-l, Allrac )
                  3PICK &COMP SWAP4PICK MULText
                  SWAPLOOP
           ROTDROP ROTDROP
           ;
   ZERO NULL{}
   ;
:: DUPLENCOMP FOUR #<case DEG2ext
   RACMULext DUP DEGREext
   #0=ITE :: DROP NULL{} SWAP ;
          :: 1GETLAM EVAL DUP COMPRIMext &COMP SWAPOVER
             RACPOLext DIVext DROP
             ;
   DUP DEGREext #0=case DROP
   SOLVext &COMP
   ;
2GETEVAL
ABND
;
**************
NULLNAME FACTOext ( polynme ou entier -> liste des facteurs ou racines )
*
::
dREALNcase :: FACT1ext SWAPDROP ;
%ABS DUP %FP %0= NOTcase ONE{}N
NULL{} SWAP %2
BEGIN
     2DUP DUP %* %>=
WHILE
     2DUP %MOD %0=
     NOTcase %1+
     ROTOVER >TCOMP UNROTSWAP OVER %/ SWAP
REPEAT
DROP >TCOMP
;
**************
NULLNAME SOLVext ( polynme-liste -> liste des racines )
( ou polynme-liste, epsilon, nombre d'itrations -> liste des racines )
* Factorise un polynme-liste  coeffcients rels ou complexes
* par la mthode de Laguerre ou de Bairstow.
::
( 6     5      4     3   2      1    )
"HALT" "RAND" NULL$ DUP "/10" "*10"
MENUext
DTYPELIST?
ITE :: ( test et nombre d'itrations aprs le test )
       THREE ID EPS 3PICK LENCOMP UNCOERCE %* ROT
       ;
    UNROTSWAP
( #itrations, epsilon, liste )
DUPLENCOMP TWO #<case :: 2DROP NULL{} ;
QOBJext CRUNCH
DUP CARCOMP 4UNROLL ( sauvegarde dnominateur )
( a0, #it, epsilon, liste )
TRIMext
{ BlankDA12 "SOLV, =" 3PICK DO>STR &$ DISPROW1
  DUP DO>STR DISPROW2
  THREE TWO &$ DISPROW3
  }
User1IT
DUPINCOMP FALSE SWAP
ZERO_DO (DO) ( Teste s'il y a un complexe dans la liste )
        SWAP TYPECMP? OR
        LOOP
( a0, #it, epsilon, liste , true ou false )
ITE :: INNERCOMP #1+DUP
       ONE_DO
              DUPROLL DTYPEREAL? IT :: %0 %>C% ;
              SWAPLOOP
       #1-{}N
       ( Laguerre ) NULL{} %0 ROT
       BEGIN
            DUPLENCOMP
            { DUP#1- UNCOERCE DO>STR EIGHT TWO &$ SWAP &$ DISPROW5
              SIX SEVEN &$ DISPROW6 }
            User1IT
            THREE #>
       WHILE
            %1 UNROT DUPLENCOMP  #1- UNCOERCE DUP %1- 2DUP %* %2 %*
            BEGIN
                 4PICK 6PICK HORNext UNROT HORNext TEN ROLL UABS
                 DUP DO>STR DISPROW7 TWELVE PICK %>
                 GETTOUCH
                 IT :: { :: ( Epsilon * 10 )
                            TWELVE ROLL %10* "= " OVER DO>STR
                            &$ DISPROW1 TWELVE UNROLL
                            ;
                         :: ( Epsilon / 10)
                            TWELVE ROLL %10 %/ "= " OVER DO>STR
                            &$ DISPROW1 TWELVE UNROLL
                            ;
                         :: ( Random ) TEN ROLL DROP
                            URAND %.5 %- URAND %.5 %- %>C% TEN UNROLL
                            ;
                         ( Stop ) DROPFALSE
                         ( Autres touches ) DROP
                         }
                       { kcMenuKey1 kcMenuKey2 kcMenuKey5 kcMenuKey6 }
                       ROT GETEVext
                       ;
            WHILE
                 UNROT HORNext UNROT2DROP 3PICK x*
                 4PICK x* OVER 6PICK x* DUP x* SWAP x-
                 U\v/ 2DUP x+ UNROT x- DUP UABS 3PICK UABS %>
                 IT SWAP
                 DROPDUP UABS %0=
                 ITE :: 2DROP URAND %.5 %- URAND %.5 %- %>C% ;
                     :: U/ 4PICK x* ;
                 DUP 7UNROLL 6ROLL SWAP x- 5UNROLL
            REPEAT
            4ROLLSWAP U/ x- 5UNROLL 4DROP %1 ELMG3ext
            { DUP DO>STR DISPROW4 } User1IT
            4ROLLOVER >TCOMP 4UNROLL HORNext 2DROP
       REPEAT
       SWAPDROP
       ( fin de Laguerre )
       ;
       :: ( Bairstow ) SWAP %>%% SWAPINCOMP  #1+DUP
          ONE_DO
                 DUPROLL %>%%
                 SWAPLOOP
          #1-{}N DUP CARCOMP ' %%/ LOPAext
          NULL{} %%0 DUPDUP 7UNROLL 4ROLL
          BEGIN
               ( pile = %%decal, #it eps [rac] s p P )
               DUPLENCOMP #1- OVER TWO NTHCOMPDROP
               ( conditionne le polynme: somme des racines=0 )
               SWAP UNCOERCE%% %%/ %%CHS DUPUNROT PTAYLext
               ( %%decal, #it eps {rac} s p %%-newdecal P )
               8ROLL ROT %%+ 7UNROLL
               ( %%decal #it eps {rac} s p P )
               DUPLENCOMP
               { DUP#1- UNCOERCE DUP %1 %- DO>STR "," &$ SWAP DO>STR &$
                 EIGHT TWO &$ SWAP &$ DISPROW6 }
               User1IT
               DUP FIVE #=ITE
                  :: ( s, p, P , #5 -> s, p , P ) DROP UNROT2DROP
                     DUPINCOMP DROP 4ROLLDROP 4ROLLDROP ( P, c,d,e)
                     2DUP 5PICK %%2 %%CHS %%/ UNROT ( P, c,d,e,-c/2,d,e )
                     %%CHS SWAP ( P, c,d,e,-c/2,-e,d )
                     6PICK 5PICK %%* ( P,c,d,e,-c/2,-e,d,ce )
                     SWAPDUP %%* %%4 %%/ %%- %%2 %%/
                     %%1 4UNROLL
                     ( P,c,d,e,1,-c/2,-e,-d^2/8+ce/2)
                     FOUR {}N DEG2ext THREE NTHCOMPDROP
                     ( P, c,d,e,a)
                     %>%% DUP %%2 %%* 5ROLL %%- %%ABS %%SQRT
                     ( P, d,e,a,sqrt[2a-c] )
                     4ROLL %%0>= ?SKIP %%CHS
                     ( P, e,a, s )
                     4UNROLL DUPDUP %%* ( s,P,e,a,a^2 )
                     ROT %%- %%ABS %%SQRT %%+ SWAP ( %%decal #it eps {rac}, s,p,P)
                     6ROLL DROPONE 6UNROLL TRUE
                     ;
                :: FOUR #> ;
          WHILE
               6PICK ( nombre d'itrations ) DUP ( remplace poly B)
               ZERO_DO (DO) ( 2 itrations aprs le test < EPS )
                       ( [rac] s p P B )
                       DROPDUP 4UNROLL UNROT BAIRSText
                       4UNROLL 3PICK 5UNROLL BAIRSText
                       4ROLLDROP INCOMPDROP 5ROLL INCOMPDROP
                       ( pile =  [rac] Po B s p c[n-3] c[n-2] b[n-1] b[n] )
                       6PICK 4PICK %%* 6PICK 6PICK %%* %%-
                       ( [rac] Po B s p c[n-3] c[n-2] b[n-1] b[n] c[n-1] )
                       OVER 6PICK %%* 5PICK 5PICK %%* %%-
                       ( [rac] Po B s p c[n-3] c[n-2] b[n-1] b[n] c[n-1] S )
                       5PICK 4ROLL %%* 4ROLL 4PICK %%* %%-
                       ( [rac] Po B s p c[n-3] c[n-2] c[n-1] S P )
                       4ROLL DUP %%* (  %%SQ )
                       5ROLL 5ROLL %%* %%-
                       DUP %%0=
                       ITE :: DROP URAND %.5 %- %>%% ;
                           %%1/
                       ( [rac] Po B s p S P D^-1 )
                       DUPROT %%* UNROT %%*
                       ( [rac] Po B s p Dp Ds )
                       DUP %%ABS 3PICK %%ABS %%+ 5UNROLL
                       ( [rac] Po B |Dp+Ds| s p Dp Ds )
                       UNROT %%+ UNROT %%+
                       ( [rac] Po B |Dp+Ds| p s )
                       DUP 6UNROLL %%ABS
                       ( [rac] s Po B |Dp+Ds| p |s| )
                       OVER %%ABS %%+ ROTSWAP
                       ( decal it eps [rac] s Po B p |Dp+Ds| |s|+|p| )
                       DUP %%0=
                       ITE :: 3DROP ROTDROP URAND %.5 %- %>%% UNROT
                              URAND %.5 %- %>%% TRUE ;
                           :: %%/
                              { SEVEN OVER %%>% DO>STR &$ DISPROW7 }
                              User1IT
                              GETTOUCH
                              ( decal it eps [rac] s Po B p %%test )
                              IT :: { :: ( Epsilon * 10 )
                                         7ROLL %%10 %%* "=" OVER
                                         %%>% DO>STR &$ DISPROW1 7UNROLL
                                         ;
                                      :: ( Epsilon / 10)
                                         7ROLL %%10 %%/ "=" OVER
                                         %%>% DO>STR &$ DISPROW1 7UNROLL
                                         ;
                                      :: ( Random s and p )
                                         2DROP ROTDROP URAND %.5 %-
                                         %>%% UNROT URAND %.5 %- %>%% %%1
                                         ;
                                      :: ( Stop ) DROP %%0 8PICK INDEXSTO ;
                                      :: ( Autres touches ) DROP ;
                                      }
                                    { kcMenuKey1 kcMenuKey2 kcMenuKey5 kcMenuKey6 }
                                    ROT GETEVext
                                    ;
                              7PICK %%>
                              ;
                       IT :: ZERO INDEXSTO ;
                       UNROT
                       LOOP
               SWAPDROP ( [rac] s p B )
               3PICK %%2 %%/ DUPDUP %%*
               ( [rac] s p B .5*s .25*s^2 )
               4PICK %%- DUP %%0>=
               ( %%decal #it eps {rac} s p B .5*s delta >=0? )
               ( 9        8  7    6    5 4 3  2    1 )
               ITE :: %%SQRT 2DUP %%+ TEN PICK %%+ %%>%
                      UNROT %%- NINE PICK %%+ %%>% TRUE ;
                   :: THIRTEEN TestUserFlag
                      NOTcase2drop :: %%1 4PICK %%CHS 4PICK THREE
                                      {}N 8PICK %%CHS PTAYLext INCOMPDROP
                                      %%>% UNROT %%>% UNROT %%>% UNROT
                                      THREE {}N FALSE
                                      ;
                      SWAP NINE PICK %%+ SWAP %%CHS %%SQRT
                      2DUP %%CHS %%>C% UNROT %%>C% TRUE
                   ;
               ( [rac] s p B r1 r2 true ou [rac] s p B {poly} false )
               ITE :: { DUP DO>STR DISPROW4 OVER DO>STR DISPROW5 } User1IT
                      6ROLL INNERCOMP #2+ ;
                   :: { DUP DO>STR DISPROW4 NULL$ DISPROW5 } User1IT
                      5ROLL INNERCOMP #1+
                      ;
               {}N 4UNROLL
          REPEAT
          ( %%decal #it eps {rac} s p P )
          UNROT2DROP
          ( %%decal #it eps {rac} P )
          5ROLL %%CHS PTAYLext
          ( fin de Bairstow )
          ;
FIFTEEN TestUserFlag SWAP FIFTEEN ClrUserFlag DEG2ext
SWAP IT :: FIFTEEN SetUserFlag ;
SWAP &COMP
UNROT2DROP INNERCOMP reversym {}N
DispMenu.1
( reconstruction des racines sous forme formelle si possible )
THIRTEEN TestUserFlag FIFTEEN TestUserFlag AND
NOTcase SWAPDROP
# 31415 JstGETTHEMSG DISPROW7
NULL{} UNROT TRUE
BEGIN
     OVER LENCOMP #>1 AND
WHILE
     INNERCOMP get1 FALSE 3PICK #1-
     ( r1, ..., rn, #n , deno, FALSE, #n )
     ZERO_DO (DO)
             ( r1, ..., rn, #n, deno, FALSE ou rn-2,#n, deno, {rn-1 rn}, TRUE )
             ITE :: ExitAtLOOP TRUE
                    ;
                 :: FALSE 3PICK INDEX@ #1+
                          DO
                          ( ...,rn, #n, deno, FALSE/rn-2,#n, deno, {rn-1 rn}, TRUE )
                          ITE :: ExitAtLOOP TRUE
                                 ;
                              :: JINDEX@ #3+ PICK INDEX@ #4+ PICK
                                 2DUP x+ UNEG UNROT x* %1 UNROT
                                 THREE {}N ( #n, deno, poly )
                                 OVER MULText DUP QOBJext :: %0 URND ;
                                 SWAPOVER SOUSext ELMGext TRIMext
                                 NULext EQUALNOTcase DROPFALSE
                                 JINDEX@ #4+ ROLLDROP INDEX@
                                 #3+ ROLLDROP DEG2ext TRUE
                                 ;
                          LOOP
                    ;
             LOOP
     case :: ( r1, ..., rn-2, #n-2, deno, {rn rn-1} )
             SWAP >HCOMP OVER UNROLL #2- {}N SWAP INCOMPDROP TWO {}N
             4ROLL &COMP UNROTSWAP TRUE
             ;
     OVER#2+UNROL {}N FALSE
REPEAT
ROT DUPNULL{}? IT :: FIFTEEN ClrUserFlag ;
&COMP SWAPDROP
;
**************
NULLNAME EVIDENText ( polynme-liste -> liste de racines )
* Recherche les racines rationnelles d'un polynme (permet aussi de
* factoriser certains polynmes  coefficients formels)
::
FOURTEEN TestUserFlag NOTcase :: NULL{} SWAP ;
TRIMext DUP LPGCDext DUP %0 EQUAL OVER %1 EQUAL OR
?SKIP DIVext DROPDUP DUPLENCOMP FOUR
#<case :: DROP DEG2ext NULL{} ;
INNERDUP ROTSWAP UNROLL #2- NDROP SWAPDUP DIVISext
( ..., a0, { diviseurs } )
{ BlankDA12 TWO FOUR &$ DISPROW1
  FIVE 3PICK DO>STR &$ DISPROW2
  DUPLENCOMP UNCOERCE DO>STR ONE &$ OVER DO>STR &$ DISPROW3 }
User1IT
SWAPDROP
( ..., { diviseurs } )
INNERCOMP get1 DUP DIVISext
( ..., diviseurs, #d, an, {num} )
{ BlankDA12 3PICK UNCOERCE DO>STR ONE &$ DISPROW1
  FIVE 3PICK DO>STR &$ DISPROW2
  DUPLENCOMP UNCOERCE DO>STR TWELVE &$ DISPROW3 DUP DO>STR DISPROW4
  }
User1IT
SWAPDROP
( stack= dnominateurs, #dno, { numrateurs } )
"HALT" NULL$ DUPDUP 2DUP
MENUext
NULL{} 3PICK
ZERO_DO (DO)
        ( stack = dno, #dno, {numrateurs}, {test} )
        OVER INNERCOMP get1
        ( stack = dnos, #dno, { num}, nums, #num, {test} )
        OVER #5+ ROLL
        ( dnos, #dno, {num}, nums, #num, {test}, dno )
        { ONE TEN &$ JINDEX@ UNCOERCE DO>STR &$ DISPROW5 }
        User1IT
        ROT
        ZERO_DO
                ( dnos, {num}, nums, {test}, dno )
                ROTOVER U/
                ( dnos, {num}, nums, {test}, dno, t)
                ROTSWAP
                ( dnos, {num}, nims, dno, {test}, t)
                DUPUNROT UNEG >TCOMP
                SWAP >TCOMP 
                SWAPLOOP
        DROP
        ( stack = dno, #dno, {numrateurs}, {test} )
        ( teste appui d'une touche, interruption )
        GETTOUCH 
        ITE :: kcMenuKey6 #= ;
            FALSE
        IT  :: ONE TestUserFlag
               NOTcase :: BlankDA12 ONE SetUserFlag ;
               ExitAtLOOP INDEX@ #1+
               ( dno, #dno, {num}, {test}, index)
               4ROLLSWAP #-
               ( dnos, {num}, test , #dnos)
               DUP4UNROLL
               #3+ UNROLL OVER#2+UNROL
               NDROP ZERO ROT
               ( {num}, #0, test )
               ;
        LOOP
UNROT2DROP
( P, tests )
INNERCOMP #1+ %0 SWAP
{ THIRTEEN OVER UNCOERCE DO>STR &$ SEVEN &$ DISPROW5 } User1IT
reversym
{}N DUPLENCOMP NULL{} SWAP#1+ DUP 5UNROLL
ONE_DO (DO)
       ( #test, P, {valeurs}, { racines } )
       OVERINDEX@ NTHCOMPDROP 4PICKSWAP
       BEGIN
            ( P, {valeurs}, { racines }, P, ek )
            { SEVEN OVER DO>STR &$ DISPROW6 }
            User1IT
            HORNext %0 EQUAL
            ( P, {valeurs}, {racines}, Q, ek, test )
       WHILE
            { DUP DO>STR ELEVEN TWO &$ &$ DISPROW7 }
            User1IT
            ROTOVER >TCOMP UNROT 5ROLLDROP SWAP
            ( {valeurs}, {racines}, ek, Q )
            DUPLENCOMP FOUR
            #<case  :: DEG2ext ROT &COMP
                       ( {valeurs}, ek, {racines} )
                       ROTDROP ExitAtLOOP
                       ( ek, {racines} )
                       { %1 } DUPUNROT
                       ( ek, P, {racines}, P )
                       4ROLL DUP4UNROLL
                       ( P, ek, {racines}, P, ek )
                       ;
            DUP 5UNROLL SWAP 
       REPEAT
       2DROP
       ( #tests, P div, {valeurs}, {racines} )
       GETTOUCH
       ITE :: kcMenuKey6 #= ; FALSE
       IT :: ONE TestUserFlag
             case ExitAtLOOP
             BlankDA12 ONE SetUserFlag
             ;
       LOOP
SWAPDROPSWAP ROTDROP
DispMenu.1
;
**************
NULLNAME DEG2ext ( polynme-liste de degr < 3 -> liste des racines )
* Factorisation d'un polynme de degr 2 (ventuellement formel)
::
DUPNULL{}? ?SEMI
DUP CARCOMP
CK&DISPATCH1
#53F :: DROP DUPLENCOMP
        FOUR #=casedrop
        :: DUPTWO NTHCOMPDROP %%3 %%/ %%CHS DUPUNROT PTAYLext DUP
           INCOMPDROP ROTDROP
           3PICK %%2 %%* %%/ %%CHS SWAPROT %%3
           %%* %%/ DUP 2DUP %%* %%* 3PICK DUP %%* %%+
           DUP %%0>=
           case :: SWAPDROP %%SQRT 2DUP %%+ UNROT %%-
                   ' ::  DUP %%0= ?SEMI DUP %%0>
                         DUPUNROT ?SKIP %%CHS %%LN %%3 %%/
                         %%EXP SWAP ?SKIP %%CHS
                         ;
                   DUPUNROT EVAL UNROT EVAL %%+
                   HORNext DROP 3PICK %%+ %%>% UNROT
                   SWAP %%CHS PTAYLext DEG2ext SWAP >TCOMP
                   ;
           DROP %%CHS %%SQRT DUP %%2 %%* UNROT DUPDUP %%* %%* %%/
           DUP %%ABS %%1 %%> ITE :: %%0>= ITE %%0 %%2PI %%2 %%/ ;
                             %%ACOSRAD
           THREE
           ZERO_DO (DO)
                   %%2PI %%+ 2DUP %%3 %%/ %%COSRAD %%* 5PICK %%+ %%>% 5UNROLL
                   LOOP
           4DROP THREE {}N
           ;
        #>2case :: ( degr 2 a, b, c ) DUP INCOMPDROP
                   3PICK %%/ SWAPROT %%2 %%* %%/ %%CHS DUPDUP %%*
                   ROT %%- DUP %%0>=
                   case :: %%SQRT 2DUP %%+ %%>% UNROT %%- %%>%
                           TWO{}N SWAPDROP
                           ;
                   THIRTEEN TestUserFlag
                   NOTcase2drop :: INCOMPDROP %%>% UNROT %%>%
                                   UNROT %%>% UNROT THREE {}N ONE{}N
                                   ;
                   %%CHS %%SQRT 2DUP %%CHS %%>C% UNROT
                   %%>C% TWO{}N SWAPDROP
                   ;
        ( degr 1) INCOMPDROP SWAP %%/ %%CHS %%>% ONE{}N
        ;
#50 :: DROPDUP LPGCDext DUP %0 EQUAL OVER %1 EQUALOR
       ?SKIP DIVext
       DROPDUP DEGREext
       DUP#0=csedrp :: DROP NULL{} ;
       DUP#1= casedrop :: INCOMPDROP UNEG SWAP RDIVext ONE{}N ;
       #>2case SOLVext
       INCOMPDROP %2 RMULText ROT %2 RMULText DUPROT RMULText
       3PICK DUP RMULText SWAP RSUBext %2 XSQRext OVER RDIVext
       UNROT UNEG RDIVext SWAP2DUP RSUBext UNROT RADDext TWO{}N
       ;
;
**************
NULLNAME RACMULext ( polynme-liste P -> P, PGCD{P,P'} )
* Calcule le PGCD des polynmes P et P' pour dterminer
* ses racines multiples (si le User Flag 2 est arm)
::
TWELVE TestUserFlag NOTcase { %1 }
DUPDUP DERext PGCDext
;
**************
NULLNAME ADDext ( { poly2 } { poly1 } --> { poly2 + poly1 } )
* Additionne deux polynmes listes
::
RESOROMP RADDext ASOPext
;
*****************************************************************
NULLNAME SOUSext ( { poly2 }, { poly1 } --> { poly2 - poly1 } )
* Soustrait deux polynmes listes
::
RESOROMP RSUBext ASOPext
;
*****************************************************************
NULLNAME MULText ( { poly2 }, { poly1 } --> { poly2 * poly1 } )
* Multiplie deux polynmes listes
::
CK&DISPATCH1
2REAL %*
THIRTYFOUR x*
any
::
RESOROMP ASOPext
RESOROMP RADDext
RESOROMP RMULText
' :: CK&DISPATCH1
     2LIST :: DUPLENCOMP 3PICK LENCOMP
              ( A, B, #b, #a )
              #< IT SWAP
              ( A, B avec #a<#b )
              INNERCOMP get1 INNERCOMP reversym get1
              ( b1, ..., bn, ak, ..., a1, #a, #b )
              2DUP#+ DUP NULL{} OVER
              ( b1, ..., bn, ak, ..., a1, #a, #b, #t, decal, {}, #t )
              ONE_DO (DO)
                     ( b1, ..., bn, ak, ..., a1, #a, #b, #t, decal, {} )
                     SWAP#1-
                     ( #a, #b, #t, {}, decal )
                     %0 INDEX@ 7PICK
                     ( #a, #b, #t, {}, decal, %0, #j , #a )
                     2DUP#<
                     ITE :: ( si index<#a alors fin=index+8, debut=8)
                            DROP #8+ EIGHT
                            ;
                         :: #8+ SWAPDUP 8PICK #MIN #- #8+
                            ( si #a<= index<#b alors fin=#a+8, debut=8)
                            ( si j>=#b, fin=#a+8 et debut=j-#b+8 )
                            ;
                     ( b1,...,bn, ak,...,a1, #a,#b, #t, {}, decal, %0, fin, debut )
                         DO
                         ( b1,...,bn, ak,...,a1, #a,#b, #t, {}, decal, coef )
                         OVERINDEX@
                         ( decal, coef, decal, i )
                         DUP#1+PICK UNROT
                         ( decal, coef, a, decal, i )
                         #+PICK 1GETLAM EVAL ( MULText )
                         3GETLAM ( RADDext ) 4GETLAM ( ASOPext ) EVAL
                         LOOP
                     ROTSWAP >TCOMP
                     LOOP
              SWAPDROP OVER#2+UNROL NDROP UNROT2DROP
              ;
     EIGHTY :: 2GETLAM ( RMULText ) LOPAext ;
     list :: SWAP 2GETLAM LOPAext ;
     any 2GETEVAL
     ;
4NULLLAM{} BIND
1GETLAM EVAL ABND
;
;
**************
NULLNAME DIVext ( obj2, obj1 -> obj2 DIV obj1 , obj2 MOD obj1 )
* Division euclidienne de 2 polynmes-listes ou de 2 rels
* calcule le quotient et le reste
::
DTYPELIST? IT :: TRIMext DUPLENCOMP #1= IT CARCOMP ;
CK&DISPATCH1
2LIST :: SWAP TRIMext DUPLENCOMP ROT DUPLENCOMP ROT
         #>case :: CARCOMP %0 MMULText ONE{}N SWAP ;
         RESOROMP RMULText RESOROMP RSUBext { NULLLAM NULLLAM } BIND
         ( B, A -> B div A, B mod A  si len B >= len A >= 2 )
         INNERCOMP get1 INNERCOMP reversym get1 #1-
         ( a1, ..., aa, bb, ..., b1, #b, #a-1 )
         2DUP #- UNROT 2DUP#+
         ( a1, ..., aa, bb, .., b1, #D=#b-a+1, #b, #a,#t-1 )
         %1 OVER #6+ ROLL RDIVext
         ( a2, ..., aa, bb, .., b1, #D, #b, #a-1, #t, a1^-1 )
         6ROLL OVER 2GETEVAL 6UNROLL SWAP#1-
         ( a2, ..., aa, bb, ..., q1, #D, #b, #a-1, a1^-1, #t-2 )
         5PICK DUP#1=
         ( calcul du quotient )
         :: caseDROP
            ONE_DO (DO)   ( 1 <=j <#D -> fin=j, debut=0 ou j+1-#a )
                   #1- INDEX@ DUP #7+ ROLLSWAP
                   ( #D, #b, #a-1, a1^-1, decal, bj+1, j  )
                   5PICK OVER #MIN SWAP #8+ DUPROT #-
                   ( #D, #b, #a-1, a1^-1, decal, bj+1, fin, debut )
                     DO
                     ( #D, #b, #a, a1^-1, decal, coef )
                     OVERINDEX@ DUP#1+PICK UNROT
                     #+PICK 2GETEVAL 1GETLAM EVAL
                     LOOP
                   3PICK 2GETEVAL INDEX@ #6+ UNROLL
                   LOOP
            ;
         4PICK 6PICK ( calcul du reste )
               DO ( fin=#b-a+1, debut=0 ou j+1-a )
               #1- INDEX@ DUP #7+ ROLLSWAP
               7PICK #8+ SWAP 6PICK OVER #MIN #- #8+
               ( #D, #b, #a-1, a1^-1, decal, bj+1, fin, debut )
                 DO
                 ( #D, #b, #a-1, a1^-1, decal, coef )
                 OVERINDEX@ DUP#1+PICK UNROT
                 #+PICK 2GETEVAL 1GETLAM EVAL
                 LOOP
               INDEX@ #6+ UNROLL
               LOOP
         ( a2, ..., aa, bb, ..., q1, #D, #b, #a-1, a1^-1, #a-2 )
         2DROP SWAP #2+ reversym {}N
         ( a2, ..., aa, { a D q1 ... qb } )
         DUP CARCOMP SWAPOVER #2+UNROLL NDROP
         ( { a D q1 ... qb } )
         CDRCOMP DUP CDRCOMP SWAP CARCOMP 2DUP ONESWAP SUBCOMP
         UNROT #1+ MINUSONE SUBCOMP
         ABND
         ;
EIGHTY ::  RESOROMP RDIVext LOPAext
           DUP CARCOMP %0 ' x* LOPAext ONE{}N ;
list :: CARCOMP %0 MMULText ONE{}N SWAP ONE{}N ;
2REAL :: TEN TestUserFlag
         case :: 2DUP %/ %FLOOR DUP4UNROLL %* %-
                 ;
         RDIVext %0
         ;
any :: RDIVext DUP %0 x* ;
;
**************
NULLNAME DERext ( polynme-liste -> drive )
::
INNERDUP
#1=case :: DROP %0 ' RMULText LOPAext ONE{}N ;
DUP #2= case2drop ONE{}N
UNROTDROP OVER UNROLL DUPTWO
    DO
    SWAPINDEX@ UNCOERCE ' RMULText LOPAext OVER UNROLL
    LOOP
#1-{}N
;
*************
NULLNAME INTEGRext ( polynme-liste -> primitive )
* calcule la primitive s'annulant en 0
::
INNERCOMP #1+DUP
ONE_DO (DO)
       SWAPINDEX@ UNCOERCE RESOROMP RDIVext LOPAext OVER UNROLL
       LOOP
%0 SWAP {}N
;
**************
NULLNAME LOPAext ( liste, objet, oprateur binaire -> liste )
* List Operation All
::
' :: dLISTcase LISTSECOext
     3GETLAM 2GETEVAL
     ;
4NULLLAM{} CDRCOMP BIND
1GETLAM EVAL
ABND
;
**************
NULLNAME LOPMext ( objet, liste -> { objet * elements de liste } )
* List Operation Multiplication
::
INNERCOMP get1 OVER
ZERO_DO (DO)
        ROTOVER MULText 3PICK #2+UNROLL
        LOOP
DROP {}N
;
**************
NULLNAME LRDMext ( liste #entier -> liste )
* Left ReDiMension
* Rajoute des 0  gauche pour obtenir un polynme "de degr" gal 
* l'entier spcifi
::
#1+ OVER LENCOMP 2DUP
#<case :: DUPROT #-+1 SWAP SUBCOMP ;
#-OVER CARCOMP %0 MMULText SWAP NDUPN {}N SWAP &COMP
;
**************
NULLNAME RRDMext ( liste entier -> liste )
* Right ReDiMension: comme LRDM mais cre des zeros  droite
::
#1+ OVER LENCOMP 2DUP
#<case :: DROP ONESWAP SUBCOMP ;
#-OVER CARCOMP %0 MMULText SWAP NDUPN {}N &COMP
;
**************
NULLNAME TRIMext ( liste -> liste )
* Enlve les zros en tte de liste
::
DTYPELIST? NOT?SEMI
DUPLENCOMP OVER DEGREext OVERSWAP #-SWAP SUBCOMP
;
**************
NULLNAME DIVEext ( poly-liste, poly-liste -> P1 DIV P2, P1 MOD P2 )
* division euclidienne,  un polynme inversible prs.
::
CK&DISPATCH1
2LIST :: TRIMext DUP CARCOMP
         :: CK1&Dispatch
            real :: DUP %ABS DUP %FLOOR %<>
                    ;
            idnt FALSE
            any TRUE
            ;
         casedrop DIVext
         SWAP DUPLENCOMP ROTSWAP UNCOERCE x^
         ROT INNERDUP #2+ DUP#1+ ROLL ROT
         ZERO_DO (DO)
                 OVER ROLL OVER RMULText UNROT
                 LOOP
         DROP #2- {}N SWAP DIVext DUPLENCOMP
         #1=case :: CARCOMP %0 EQUAL ITE %0 %1 ONE{}N ;
         DUP LPGCDext DUP %0 EQUAL OVER %1 EQUALOR
         ?SKIP DIVext DROP
         ;
2REAL :: 2DUP %MOD ROTOVER %- ROT %/ SWAP ;
any DIVext
;
**************
NULLNAME DEGREext ( objet -> degre )
* renvoie le degr d'un polynme-liste
::
CK&DISPATCH1
list :: DUPLENCOMP TWO
        #<case DROPZERO
        INNERCOMP #1+
        [BEGIN]
             DUPROLL DUP %0 EQUAL SWAP C%0 EQUAL OR OVER TWO #> AND
        [WHILE]
             #1-
        [REPEAT]
        DUPDUP UNROLL #2- NDROP #2-
        ;
real %ABSCOERCE
TWO :: C%ABS COERCE ;
any DROPZERO
;
**************
NULLNAME RACPOLext ( liste de racines ou de facteurs -> polynme ou entier )
* Inverse de FACTO. Si le UserFlag 10 est arm, il s'agit de facteurs
* entiers, sinon de racines.
::
TEN TestUserFlag
case :: INNERCOMP
        DUP#0=csedrp %1
        %1 SWAP
        ZERO_DO (DO)
                x*
                LOOP
        ;
' :: INNERCOMP
     DUP#0=csedrp :: %1 ONE{}N ;
     ONE #=casedrop :: DTYPELIST? ?SEMI xNEG %1 SWAP TWO{}N
                            ;
     TWO #=casedrop :: CK&DISPATCH1
                       2LIST MULText
                       list :: DUPUNROT LOPMext SWAP %0 >TCOMP SWAP SOUSext
                               ;
                       EIGHTY :: OVER LOPMext SWAP %0 >TCOMP SWAP SOUSext
                                 ;
                       any :: 2DUP RMULText UNROT RADDext xNEG %1
                              SWAPROT THREE {}N
                              ;
                       ;
     DUP #2/ SWAPOVER #- OVER#2+UNROL {}N 1GETLAM EVAL
     OVER#2+UNROL {}N 1GETLAM EVAL MULText
     ;
DUP1LAMBIND
EVAL
ABND
;
**************
NULLNAME FXNDext ( objet -> numrateur, dnominateur )
* Dcompose une fraction
::
DUPTYPESYMB? NOTcase %1
INNERCOMP
' :: SWAP' xNEG
     EQUALcasedro :: #1- 1GETLAM EVAL SWAP xNEG SWAP ;
     ' x/
     EQUALcasedro :: #1- pshzerpsharg DUP#1=
                     ITE_DROP SYMBN
                     OVER#2+UNROL DUP#1=
                     ITE_DROP SYMBN
                     ;
     SWAP SYMBN %1
     ;
DUP1LAMBIND EVAL ABND
;
**************
NULLNAME NDXFext ( numrateur, dnominateur -> algbrique )
* inverse de FXND
::
OVER num0=case 2DROP
DROP dREALNcase x/
%1=case DROP
%-1=case :: DROP UNEG ;
' U/ THREE SYMBN
;
**************
NULLNAME LVARext ( objet -> liste des identificateurs globaux )
::
TWO BINDext
:: ( liste, list ou symb -> liste )
   INNERCOMP get1 SWAP
   ZERO_DO (DO)
           ( o1, ..., ok, liste )
           1GETLAM EVAL
           LOOP
           ;
:: ( objet, liste -> liste )
   SWAP
   ( liste, objet )
   CK&DISPATCH1
   idnt apndvarlst
   symb 2GETEVAL
   list 2GETEVAL
   any DROP
   ;
NULL{} 1GETLAM EVAL ABND
;
**************
NULLNAME VALext ( P, x -> P[x] ou P, { x1,..., xn } -> P[x1,...,xn] )
::
DUP
' :: DTYPELIST? IT :: DUPLENCOMP #1= IT INCOMPDROP ;
     CK&DISPATCH1
     2LIST :: DUP CARCOMP SWAP CDRCOMP ROT ( idnt, lvar, poly )
              INNERDUP #2+ SWAP
              ZERO_DO ( idnt, lvar, poly1, ..., polyn, #n+2 )
                      DUPPICK OVER ROLL SWAP 2GETEVAL
                      SWAPLOOP
              #2- {}N SWAPDROPSWAP 2GETEVAL
              ;
     #56 :: ( liste, idnt )
* ancien code donne les monmes dans l'ordre croissant
*            SWAPINCOMP
*            ( x, an, ..., a0, #n+1 )
*            ONE #=casedrop SWAPDROP
*            get1 ( an, ..., a0, #n+1, x )
*            ROT 4ROLL 3PICK x* x+ ROT
*            ( an, ..., a2, x, 'a0+a1*x', #n+1 )
*            TWO #=casedrop SWAPDROP
*            TWO DO
*                ( an, ..., ak, x , res )
*                OVERINDEX@ UNCOERCE ' U^ THREE SYMBN
*                ( an , ..., ak, x , res, x^k )
*                4ROLLSWAP x* x+
*                LOOP
*            ( x, res )
*            SWAPDROP
            ( code donnant les monmes dans l'ordre dcroissant )
            SWAPINCOMP DUP#0<> NcaseSIZEERR
            ( X, an,...,a0, #n+1)
            reversym get1 %0
            ( a0, ..., an, #n+1, X, %0 )
            3PICK #1+_ONE_DO (DO)
                  4ROLL 3PICK 5PICK INDEX@#- UNCOERCE x^ x* x+
                  LOOP
            UNROT2DROP
            ;
     EIGHTY :: ( liste, any ) SWAPINCOMP reversym get1 SWAP
               ( a0,..., an, x , #n+1)
               ONE_DO
                      ( a0, ..., ak, res, x )
                      DUP4UNROLL RMULText RADDext
                      SWAPLOOP
               ( res, x ) DROP
               ;
     any DROP
     ;
' :: DUP#0=csedrp :: 3GETLAM 2GETEVAL ;
     #1- SWAPINCOMP
     DUP#0= case2drop NULL{}
     get1 OVER
     ZERO_DO (DO)
             ( ak, ..., an, a1,...,ak-1, #n, # )
             OVER #2+ROLL OVER
             ( ak+1, ..., an, a1,...,ak-1,#n, #, ak,#)
             1GETLAM EVAL UNROT
             LOOP
     DROP {}N
     ;
4NULLLAM{} CDRCOMP BIND
:: CK&DISPATCH1
   2LIST :: OVER DEPTHext
            SWAP LENCOMP 2DUP #< caseSIZEERR
            #- ( objet , #- )
            1GETLAM EVAL
            ;
   any 2GETEVAL
   ;
ABND
;
**************
*NULLNAME VALPext ( P,x -> P[x] )
*::
*SWAP
*CK&DISPATCH1
*list :: INNERDUP #1=
*        ITE ROT2DROP
*            :: DUP#2+ ROLL SWAP DUP#2+ ROLLSWAP DUP #3+ UNROT
*               ONE_DO (DO)
*                      3PICK MULText OVER INDEX@#- ROLL ADDext
*                      LOOP
*               UNROT2DROP
*               ;
*      ;
*;
**************
NULLNAME GETEVext ( liste d'actions liste objet -> )
* si objet est dans la liste  la position n, excute l'action n
* sinon excute la dernire action de la liste, l'objet est dans ce cas
* conserv sur la pile sinon il est dtruit
::
DUP4UNROLL EQUALPOSCOMP
DUP#0=ITE :: DROPDUP LENCOMP ;
          ROTDROP
NTHCOMPDROP EVAL
;
**************
NULLNAME PGCDext ( o2 o1 -> PGCD[o2,o1] )
* Plus grand diviseur commun (entier, polynme listes ou algbriques)
::
TWELVE TestUserFlag
NOTcasedrop :: TYPELIST? ITE { %1 } %1 ;
CK&DISPATCH1
2LIST :: BEGIN
              DUP DEGREext #0<>
         WHILE
              SWAPOVER DIVEext SWAPDROP
         REPEAT
         TRIMext { %0 } EQUAL
         NOTcasedrop { %1 }
         DUP LPGCDext num0=case DROP num1=case DROP DIVext DROP
         ;
2REAL :: %ABS %FLOOR SWAP %ABS %FLOOR SWAP
         BEGIN
              ( r1, r2 )
              DUP%0= NOT
         WHILE
              SWAPOVER %MOD
         REPEAT
         ( avant-dernier reste )
         DROPDUP ( r1, r1 ) %0= casedrop %1
         ;
THIRTYTHREE :: SWAP C%>% ROT PGCDext PGCDext ;
EIGHTY :: SWAP LPGCDext PGCDext ;
list :: LPGCDext PGCDext ;
SYMSYM :: DUP LVARext DUPLENCOMP
          #0=case :: 3DROP %1 ;
          CARCOMP DUPUNROT VXXLext UNROT DUPUNROT
          VXXLext ROT PGCDext SWAP VALext
          ;
any :: 2DROP %1
       ;
;
**************
NULLNAME SIMPext ( o1, o2 -> o1' o2' )
* Simplifie o1/o2 en o1'/o2' par division par le PGCD de o1 et o2
::
' :: TRIMext SWAP TRIMext SWAP2DUP PGCDext
     ROTOVER DIVext DROP UNROT DIVext DROP
     ;
UNROT ( prg, o2, o1 )
DUPTYPECMP? IT :: DUP C%CONJ DUPUNROT x* C>Re% UNROT x* SWAP ;
CK&DISPATCH1
2REAL :: ROTDROP 2DUP PGCDext ( r1, r2, pgcd ) ROTOVER %/ UNROT %/
         ( r1, r2 simplifies )
         DUP %0> ?SEMI
         %CHS SWAP %CHS SWAP
         ;
THIRTYTHREE :: ROTDROP 2DUP PGCDext ROTOVER U/ UNROT U/ ;
EIGHTY :: ROT EVAL ;
list :: ROT EVAL ;
any :: FOURTEEN TestUserFlag NOTcase ROTDROP
       2DUP U/ CSQRext
       case :: 4UNROLL3DROP %1 ;
       ( prg, o2, o1, o2/o1 )
       DROP
       CK&DISPATCH1
       SYMSYM :: DUP LVARext DUPLENCOMP
                 #1=case :: CARCOMP DUP4UNROLL VXXLext
                            ( prg, var, o2, l1 )
                            SWAP3PICK VXXLext
                            ( prg, var, l1, l2 )
                            4ROLL EVAL ( var, l1', l2' )
                            3PICK VALext SWAPROT VALext
                            ;
                 DROP ROTDROP
                 ;
       # 90 :: ROTDROPSWAP TOLISText NOTcase SWAP
               ROT DIVext DROPSWAP VALext %1
               ;
       symb :: ROTDROP OVER %0 EQUALcasedrp %1
               TOLISText NOT?SEMI
               ROT DIVext DROPSWAP VALext %1 SWAP
               ;
       any ROTDROP
       ;
;
**************
NULLNAME CSQRext ( algbrique -> algbrique simplifi false ou true )
* Recherche une racine carre dans l'algbrique, renvoie false s'il
* n'en trouve pas et true s'il en trouve (simplifie alors l'expression)
::
DUPTYPESYMB? NOTcase FALSE
RMSYMext DUP FSQRext NOTcase FALSE
ROT LSQRext INCOMPDROP UNROTSWAP x* x+ TRUE
;
**************
NULLNAME FSQRext ( algbrique -> false ou \sqrt{a}, a, true )
* Find SQuare Root
::
FALSE
' :: casedrop TRUE
     DUPTYPESYMB? NOTcasedrop FALSE
     DUP ' U\v/  EQUALPOSCOMP
     DUP#0=csedrp :: INNERCOMP FALSE SWAP
                     ZERO_DO (DO)
                             1GETLAM EVAL
                             LOOP
                     ;
     ONESWAP SUBCOMP INNERCOMP pshzerpsharg NDROP
     SYMBN DUPINCOMP SWAPDROP #1-
     DUP#1= ITE_DROP SYMBN TRUE
     ;
DUP1LAMBIND EVAL ABND
;
**************
NULLNAME RACext ( entier ou polynme algbrique -> racine carre )
*
::
CK&DISPATCH1
real :: DUP %SQRT DUPDUP %FLOOR %=
        case SWAPDROP
        DROP FACTOext INNERCOMP %1 DUPDUP 4ROLL
        ZERO_DO (DO)
                4ROLL 2DUP %=
                ITE :: DROP %* %1 ;
                    :: SWAPDROP ROTOVER %* UNROT ;
                LOOP
        DROP 2DUP %/
        %1=case 2DROP
        ' U\v/ TWO SYMBN x* SWAPDROP
        ;
symb :: DUP LVARext DUPLENCOMP
        #0=case :: DROP UEVAL %2 XSQRext FIFTEEN ClrUserFlag ;
        CARCOMP DUPUNROT VXXLext FACT1ext INNERCOMP NULL{}
        DUPDUP 4ROLL
        ZERO_DO (DO)
                4ROLL 2DUP EQUAL
                ITE :: DROP >TCOMP NULL{} ;
                    :: SWAPDROP ROTOVER >TCOMP UNROT ;
                LOOP
        DROP RACPOLext SWAP RACPOLext SWAP 2DUP DIVext
        DROP 5PICK VALext U\v/ 4ROLL CARCOMP %2 XSQRext x*
        4UNROLL ROT VALext SWAPDROP x*
        ;
;
**************
NULLNAME XSQRext ( objet, entier -> racine nime de l'objet )
* Sert essentiellement  prendre la racine carre d'un objet
* avec comme entier %2
::
%2=case :: DROP FIFTEEN UserITE
           :: CK&DISPATCH1
              real :: DUP %0< SWAP %ABS DUPDUP %FLOOR %<>
                      ITE U\v/ RACext SWAP NOT?SEMI C% 0 1 x*
                      ;
              TWO :: DUP C>Re% DUPDUP %FLOOR %=
                     case :: OVER C%ABS DUPDUP %FLOOR %=
                             case :: 2DUP %+ %2 RDIVext %2 XSQRext UNROTSWAP
                                     %- %2 RDIVext %2 XSQRext ROT C>Im%
                                     %0> ITE C% 0 1 C% 0 -1 x* RADDext
                                     ;
                             2DROP C%SQRT
                             ;
                     DROP C%SQRT
                     ;
              idnt :: ' U\v/ TWO SYMBN ;
              symb :: FXNDext DUPUNROT RMULText DUPTYPESYMB?
                      ITE RACext
                          :: %2 XSQRext ;
                      SWAP SIMPext NDXFext
                      ;
              ;
           U\v/
           ;
SWAP ULN SWAP U/ UEXP
;
**************
* NULLNAME TABSext ( objet -> valeur absolue ou 1 )
* Renvoie la valeur absolue pour un rel ou un complexe, sinon renvoie 1
* ::
* CK&DISPATCH1
* real %ABS
* TWO C%ABS
* any :: DROP %1 ;
* ;
**************
NULLNAME COMPRIMext ( liste -> liste comprime au sens ensembliste )
::
DUPNULL{}? ?SEMI INNERCOMP reversym NULL{} SWAP
ZERO_DO (DO)
        SWAP apndvarlst
        LOOP
;
**************
NULLNAME NEXTPext ( liste -> liste1 liste2 )
* liste=liste1+liste2, liste2 est forme d'lments identiques
( { o1 o2 ... } -> { liste1 } { o1 ... o1 } )
( si Flag3 Set liste1=liste-{o1 ... o1 } )
( si Flag3 Clear liste1=liste-{o1 ... o1}-{conj[o1]...conj[o1]} )
::
DUPLENCOMP #2
#<case :: NULL{} SWAP ;
INNERCOMP reversym SWAP THIRTEEN
UserITE :: ONE{}N DUP ;
        :: DUPDUP UCONJ ELMGext TWO{}N SWAP ONE{}N ;
NULL{} 4ROLL
ONE_DO (DO)
       :: ( on,...,ok, {o1 conj[o1]},  {o1}, { o2 ... ok-1} )
          4ROLL 4PICKOVER EQUALPOSCOMP
          ( on,...,ok+1, {o1 conj[o1]},  {o1}, { o2 ... ok-1}, ok, #pos_ok )
          DUP#0=csedrp >TCOMP
          #1= NOTcaseDROP
          ROTSWAP >TCOMP SWAP
          ;
       LOOP
ROTDROPSWAP
;
**************
NULLNAME DIVISext ( objet -> liste des diviseurs )
* objet peut tre algbrique ou entier
* dans le premier cas, DIVISext renvoie la liste des facteurs premiers
* dans le second cas, la liste des diviseurs si l'entier est <  #FFFFFh
::
CK&DISPATCH1
symb :: DUP LVARext DUPLENCOMP
        #0=case :: %1 >TCOMP SWAPDROP ;
        CARCOMP DUPUNROT VXXLext FACTOext
        INNERCOMP #2+ DUPTWO
            DO
            DUPPICK ROT x- OVER #1- UNROLL
            LOOP
        %1 SWAP#1- {}N SWAPDROP
        ;
idnt :: %1 TWO{}N ;
real :: %ABS DUP %FP %0=
        SWAP DUPDUP %1 %> SWAP % 1048576 %< AND ROT
        ( teste si on a un entier compris entre 2 et 1048575= #FFFFF )
        ANDcase
            :: NULL{} OVER >TCOMP
               SWAP COERCE { %1 } SWAP TWO
               BEGIN
                    ( { %n }, { %1 }, #n , #k )
                    DUPDUP #* 3PICK #1+ #<
                    ( #n>#k^2 ? )
               WHILE
                    2DUP #/ SWAP
                    #0<> casedrop #1+
                    ( {%n}, {%1}, #n, #k, #n/#k )
                    OVER UNCOERCE 5ROLL SWAP >TCOMP 4UNROLL
                    ( {%n}, {%1}, #n, #k, #n/#k )
                    UNCOERCE 5ROLL SWAP >TCOMP 4UNROLL #1+
               REPEAT
               2DROP SWAP INNERCOMP reversym {}N &COMP
               ;
        DROP { %1 }
        ;
any :: DROP { %1 } ;
;
**************
NULLNAME LPGCDext ( liste -> PGCD de la liste )
::
INNERCOMP
DUP#0=csedrp %1
DUP#1= caseDROP
ONE_DO (DO)
       :: num0=case DROP
          OVER num0=case DROPSWAPDROP
          DROP PGCDext
          ;
       LOOP
;
**************
NULLNAME QOBJext ( objet [ runstream: programme ] -> objet )
* Exxute programme sur les lments de objet (pour des objets
* de type liste, algbrique ou array en les dcomposant)
::
'R
' :: CK&DISPATCH1
     real 2GETEVAL
     TWO 2GETEVAL
     sym 2GETEVAL
     TAGGED :: xOBJ\-> SWAP 1GETLAM EVAL SWAP x\->TAG ;
     arry :: AXLext 1GETLAM EVAL ;
     list LISTSECOext
     any NOP
     ;
{ NULLLAM NULLLAM } BIND
1GETLAM EVAL
ABND
;
**************
NULLNAME VXXLext ( algbrique ID -> polynme-liste )
::
OVER
' :: ( partie non rcursive pour types 6,7,9: transforme LAM3 en liste )
     ( schma de pile : rien -> liste )
     3GETLAM LENCOMP
     #1+_ONE_DO
             3GETLAM INDEX@ NTHCOMPDROP
             :: CK&DISPATCH1
                idnt :: { %1 %0 } OVER 4GETLAM EQUAL IT SWAP DROP
                        ;
                symb :: 3GETLAM SWAP 3PUTLAM 2GETEVAL SWAP 3PUTLAM ;
                seco :: { ADDext SOUSext MULText
                          :: ( DIV ) SWAPOVER DIVext DUP
                             DTYPELIST? ITE { %0 } %0
                             EQUALcase DROPSWAPDROP
                             ROT SIMPext 4GETLAM VALext SWAP
                             4GETLAM VALext SWAP NDXFext ADDext
                             ;
                          :: ( ^ ) RESOROMP MULText MPext
                             ;
                          :: ( autre oprateur binaire i.e. XROOT )
                             UNROT 4GETLAM VALext SWAP
                             4GETLAM VALext SWAPROT EVAL ONE{}N
                             ;
                          :: %2 XSQRext ;
                          :: QOBJext :: xNEG CALCext ;
                             ;
                          :: DUP MULText ;
                          :: QOBJext :: xRE CALCext ;
                             ;
                          :: QOBJext :: xIM CALCext ;
                             ;
                          :: QOBJext  :: xCONJ CALCext ;
                             ;
                          :: SWAP 4GETLAM VALext SWAP EVAL ONE{}N
                             FOURTEEN ClrUserFlag
                             ;
                        }
                        { x+ x- x* U/ U^ UXROOT U\v/ UNEG USQ URE UIM UCONJ }
                        ROT GETEVext
                        ;
                any NOP
                ;
             [LOOP]
     DTYPELIST? ?SKIP ONE{}N
     ;
' :: ( partie rcursive du programme pour listes )
     ( stk: objet -> liste )
     CK&DISPATCH1
     list LISTSECOext
     idnt :: DUP ONE{}N { %1 %0 } ROT 4GETLAM EQUAL IT SWAP DROP ;
     symb :: RMSYMext 3PUTLAM 2GETLAM EVAL ;
     any ONE{}N
     ;
4NULLLAM{} BIND
1GETLAM EVAL ABND
;
**************
NULLNAME LSQRext ( \sqrt{a}, a, P[a,\sqrt{a}] -> \sqrt{a}, P-liste )
::
' :: ( SMULT : x , P1 \sqrt{x} , P2 \sqrt{x} -> x , P1*P2 \sqrt{x} )
     INCOMPDROP ROT INCOMPDROP OVER5PICK RMULText
     6PICK RMULText OVER5PICK RMULText RADDext 5UNROLL 4ROLL
     RMULText 3UNROLL RMULText RADDext SWAP TWO{}N
     ;
' :: CK&DISPATCH1
     symb :: DUP ' U\v/  EQUALPOSCOMP
             #0=case :: %0 SWAP TWO{}N ;
             2GETLAM
             EQUALcasedro :: %1 %0 TWO{}N ;
             INNERCOMP DUPUNROT #1+UNROLL #1-
             pZpargSWAPUn DUP#1=
             ITE :: DROP CK&DISPATCH1
                    symb :: 3GETLAM EVAL ;
                    any :: %0 SWAP TWO{}N ;
                    ;
                 :: SYMBN 3GETLAM EVAL ;
             OVER #3+ UNROLL DUP#0=csedrp
             :: { :: INCOMPDROP 2DUP DUP RMULText SWAPDUP RMULText
                     1GETLAM RMULText RSUBext UNROTSWAP UNEG 3PICK
                     RDIVext SWAPROT RDIVext SWAP
                     ;
                  :: INCOMPDROP UNEG CALCext SWAP UNEG CALCext
                     ;
                  :: INCOMPDROP SWAP 2GETLAM UEVAL RMULText RADDext
                     %2 XSQRext %0
                     ;
                  :: 1GETLAM SWAPDUP 4GETLAM EVAL SWAPDROP INCOMPDROP
                     SWAP ;
                  :: INCOMPDROP URE CALCext SWAP URE CALCext ;
                  :: INCOMPDROP UIM CALCext SWAP UIM CALCext ;
                  :: INCOMPDROP UCONJ CALCext SWAP UCONJ CALCext ;
                  :: SWAPINCOMP DROPSWAP 2GETLAM RMULText RADDext
                     SWAP EVAL %0 FOURTEEN ClrUserFlag
                     ;
                  }
                { UINV UNEG U\v/ USQ URE UIM UCONJ }
                ROT GETEVext SWAP TWO{}N
                ;
             DUP#1=
             ITE :: DROP CK&DISPATCH1
                    symb :: 3GETLAM EVAL ;
                    any :: %0 SWAP TWO{}N ;
                    ;
                 :: SYMBN 3GETLAM EVAL ;
             UNROT
             { :: INCOMPDROP ROT INCOMPDROP ROT
                  RADDext UNROT RADDext SWAP TWO{}N
                  ;
               :: INCOMPDROP ROT INCOMPDROP ROT
                  RSUBext UNROTSWAP RSUBext SWAP TWO{}N
                  ;
               :: 1GETLAM UNROT 4GETLAM EVAL SWAPDROP
                  ;
               :: 1GETLAM UNROT INCOMPDROP OVER %0 EQUAL
                  ITE :: SWAPDROPSWAP INCOMPDROP 3PICK RDIVext SWAPROT
                         ;
                  :: 2DUP DUP RMULText SWAP DUP RMULText 6PICK
                     RMULText RSUBext 5UNROLL SWAP UNEG CALCext
                     SWAP TWO{}N 4GETLAM EVAL INCOMPDROP 4PICK RDIVext SWAP4ROLL
                     ;
                  RDIVext SWAP TWO{}N SWAPDROP
                  ;
               :: INCOMPDROP SWAPDROP COERCE
                  DUP#0=csedrp :: DROP { %0 %1 } ;
                  DUP#1= caseDROP
                  1GETLAM 3PICK ROT
                  ONE_DO (DO)
                         3PICK 4GETLAM EVAL
                         LOOP
                         UNROT2DROP
                         ;
               :: UNROT INCOMPDROP SWAP 2GETLAM RMULText RADDext
                  SWAPINCOMP DROPSWAP 2GETLAM RMULText RADDext
                  SWAPROT EVAL %0 SWAP TWO{}N
                  FOURTEEN ClrUserFlag
                  ;
               }
             { x+ x- x* U/ U^ }
             ROT GETEVext
             ;
     list :: INNERDUP #1+SWAP
             ZERO_DO
                     DUPROLL 3GETLAM EVAL
                     SWAPLOOP
             #1-{}N
             ;
     any :: %0 SWAP TWO{}N  ;
     ;
5PICK 5ROLL 4NULLLAM{} BIND
3GETLAM EVAL
ABND
;
**************
NULLNAME VERext ( affichage de la version )
::
*  0123456789012345678901
  " ALGB Library v2.13"
  DISPROW1
  "    Bernard.Parisse"
  DISPROW3
  "Tl.: (33) 76 51 43 14"
  DISPROW4
  "  @fourier.grenet.fr"
  DISPROW5
  "Institut Fourier - UJF"
  DISPROW6
  "F38402 StMartin_dHres"
  DISPROW7
HOMEDIR % .0000000001 ' ID EPS USTO ' ID X ' ID VX USTO
% 2.13
;
**************
NULLNAME XYext ( vecteur x et y -> x.y produit scalaire )
*
::
DUPLENCOMP
#1=case :: CARCOMP SWAP CARCOMP MULText
           ;
THREE BINDext MULText RADDext ASOPext
INNERCOMP #1+ROLL INNERCOMP #2+ DUPROLL
( y1, ..., yn-1, x1, ..., xn, #n+2, yn )
ROTSWAP 3GETLAM EVAL
( y1, ..., yn-1, x1, ..., xn-1, #n+2, xn*yn )
OVER THREE
     DO
     ROT 3PICK PICK 3GETLAM EVAL 2GETLAM 1GETLAM EVAL
     LOOP
( y1, ..., yn-1, #n+2, X.Y )
OVER #1- UNROLL #3- NDROP
ABND
;
**************
NULLNAME MMULText ( matrice 1, matrice 2 -> produit des 2 matrices )
* Egalement matrice * vecteur ou matrice * rel ou polynme * polynme
::
CK&DISPATCH1
2REAL %*
THIRTYFOUR x*
EIGHTEEN x*
THIRTYTHREE x*
2LIST :: DUP CARCOMP TYPELIST? case
         :: ( A, B teste compatibilit #colonnes de A=#lignes de B )
            DUPLENCOMP 3PICK CARCOMP LENCOMP #= NcaseSIZEERR
            TRANext INNERDUP #2+ROLL
            ( vecteurs colonnes de B b1, ..., bc, #c, A )
            INNERCOMP get1 
            ( b1, ..., bc, a1, ..., an, #n, #c )
            RESOROMP MULText
            RESOROMP RADDext
            RESOROMP ASOPext
            4NULLLAM{} BIND
            ( b1, ..., bc, a1, ..., an, #n )
            DUP #3+ THREE
                [DO]
                DUPDUP 4GETLAM #+ INDEX@ #+SWAP
                ( b1, ..., bc, a1, .., an, ..., ck-1, #n, #n+#c+k+3, #n)
                #2+PICK
                ( b1, ..., bc, a1, ..., an, ..., ck-1, )
                ( #n, #n+#c+3+k, ak )
                SWAP 4GETLAM
                ZERO_DO (DO)
                        ( b1, ..., bc, a1, ..., an, ..., ck-1, )
                        ( #n, ak, #n+#c+k+3 )
                        DUPPICK 3PICK
                        ( XYext )
                        DUPLENCOMP #1=
                        ITE :: CARCOMP SWAP CARCOMP 3GETLAM EVAL
                               ;
                            :: INNERCOMP #1+ROLL INNERCOMP #2+ DUPROLL
                               ( y1, ..., yn-1, x1, ..., xn, #n+2, yn )
                               ROTSWAP 3GETLAM EVAL
                               ( y1, ..., yn-1, x1, ..., xn-1, #n+2, xn*yn )
                               OVER THREE
                                    DO
                                    ROT 3PICK PICK 3GETLAM EVAL 2GETLAM 1GETLAM EVAL
                                    LOOP
                               ( y1, ..., yn-1, #n+2, X.Y )
                               OVER #1- UNROLL #3- NDROP
                               ;
                        ( fin de XYext )
                        UNROT
                        LOOP
                ( b1, ..., bc, an, ..., a1, ..., ck-1, )
                ( #n, ak.b1, ..., ak.bc, ak, #2n+3+k )
                2DROP 4GETLAM {}N
                ( apres swap avant loop: b1, ..., bn, an, ..., a1, ...,ck , #n )
                SWAPLOOP
            ( b1, ..., bc, an, ..., a1, c1, ..., cn, #n )
            DUP 4GETLAM #+ OVER#2+UNROL {}N
            ( b1, ..., bc, an, ..., a1, #n+#c, C )
            OVER#2+UNROL NDROP
            ABND
            ;
         OVER CARCOMP TYPELIST? NOTcase MULText
         ( matrice * vecteur )
         SWAPINCOMP get1 NULL{} ROT
         ZERO_DO (DO)
                 OVER 4ROLL XYext >HCOMP
                 LOOP
         SWAPDROP
         ;
any MULText
;
**************
NULLNAME MPMULText ( matrice  coef polynmes, polynme -> matrice )
::
CK&DISPATCH1
2REAL %*
THIRTYFOUR x*
EIGHTEEN x*
THIRTYTHREE x*
2LIST :: ( l2, l1 ) 2DUPSWAP ( l2, l1, l1, l2 )
         DEPTHext SWAP DEPTHext  ( l2, l1, #n2, #n1 )
         2DUP#< 3PICK #1=
         ORcase :: 2DROP MULText ( produit de polynmes si n2<n1 ou si n2=1 )
                   ;
         #- ( l2, l1, n2-n1 )
         TWO #<case MMULText
         ( produit de 2 matrices ou matrice-vecteur si n2-n1<=2 )
         ( matrice * polynme-liste )
         1LAMBIND
         INNERCOMP NULL{} SWAP
         ZERO_DO (DO)
                 SWAPINCOMP NULL{} SWAP
                 ZERO_DO (DO)
                         SWAP 1GETLAM MULText >HCOMP
                         LOOP
                 >HCOMP
                 LOOP
         ABND
         ;
any MULText
;
***************
NULLNAME TRANext ( matrice -> matrice transpose )
*
::
CK&DISPATCH1
list :: INNERCOMP OVER LENCOMP
        ( l1, l2, ..., lm, #m, #n )
        DUP
        #1+_ONE_DO (DO)
                INDEX@ 3PICKOVER #3+ #+
                ( l1, ..., lm, ..., tk-1 ,#m, #n, #1+k, #m+4+k )
                4PICK
                ZERO_DO (DO)
                        DUPPICK 3PICK NTHCOMPDROP UNROT
                        LOOP
                SWAPDROP
                ( l1, ..., lm , .., tk-1, #m, #n, e1, ..., em, #m+4+k)
                INDEX@#- #3- {}N
                ( l1, ..., lm, #m, #n , tk )
                UNROT
                LOOP
        ( l1, ..., lm, t1, ..., tn, #m, #n)
        DUPUNROT
        ( l1, ..., lm, t1, ..., tn, #n, #m, #n)
        #2+UNROLL {}N
        ( l1, ..., lm, #m, At )
        OVER#2+UNROL NDROP
     ;
arry :: UTRN UCONJ ;
;
**************
NULLNAME TRext ( matrice -> trace )
*
::
CK&DISPATCH1
list :: INNERCOMP reversym SWAP CARCOMP SWAP
        #1+DUP #2=
        caseDROP
        TWO DO
            SWAPINDEX@ NTHCOMPDROP ADDext
            LOOP
        ;
arry :: UARRY\-> INCOMPDROP DROP COERCE DUPTWO
        #<case DROP
        { NULLLAM NULLLAM } BIND
        1GETLAM
        ONE_DO (DO)
               1GETLAM NDROP 2GETLAM x+ 2PUTLAM
               LOOP
        2GETLAM ABND
        ;
;
**************
